\ **************************************************
\ * INESC NORTE                                    *
\ *   TESTE DE ESTADO DA U.R. E VALOR DE COUNTER   *
\ *                                   Nelson Neves *
\ **************************************************
\
\ Esta rotina destina-se a mostrar o valor total da
\ contagem alem de identificar a U.R. assim como o
\ estado da mesma
\ Esta rotina nao implementa o contador parcial
\
\
forth definitions decimal

code51:           \ start of the assembler code

$2000 constant BECNT            \ buffer que guarda
                                \ paramet. das U.A.
$03   constant  NBAC            \ numero de bytes
                                \ a converter
\
        org    $0010
\
\  neste assembler primeiro as subrotinas
\
\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\
\
\ Rotina de envio de CaRacTer para o LCD
\
label   CRT
        MOV     R1 , A             \
        begin
           MOV     DPTR , # $FFFE  \
           SETB    P1.1            \
           CLR     P1.0            \
           MOVX    A , @DPTR       \ "BUSY FLAG"
           SETB    P1.0            \
           RLC     A               \
        until /c?                  \
        MOV     A , R1            \
        MOV     DPTR , # $FFFF  \
        CLR     P1.1            \
        CLR     P1.0            \
        MOVX    @DPTR , A       \ "DATA REGISTER"
        SETB    P1.0            \
        SETB    P1.1            \
        RET                     \
\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


\ Mensagens a enviar para o LCD
\
label   SAY

        MOV     R0 , # $09      \
        ADD     A , R0          \
        MOV     R0 , A          \
begin
        MOV     A , R0            \
        MOVC    A , @A+PC         \ A=caracter
        if  A= # ASCII }          \ compara com "}"
            RET                   \
        endif
        ACALL   CRT             \
        INC     R0              \ novo caracter
again
\
        string   "UR.}"          \ #00H
        string   "off   }"       \ #04H
        string   "avaria}"       \ #0BH
        string   "manut.}"       \ #12H
        string   "on    }"       \ #19H
        string   "E:}"           \ #20H
        string   "C:}"           \ #23H
                                 \ next byte #26H
\
\ Rotina de envio de CoManDo para o LCD
\
label   CMD
        MOV     R1 , A            \
        begin
           MOV     DPTR , # $FFFE  \
           SETB    P1.1            \
           CLR     P1.0            \
           MOVX    A , @DPTR       \ "BUSY FLAG"
           SETB    P1.0            \
           RLC     A               \
        until /c?
        MOV     A , R1          \
        MOV     DPTR , # $FFFE  \
        CLR     P1.1            \
        CLR     P1.0            \
        MOVX    @DPTR , A       \ "INSTRUCTION REGISTER"
        SETB    P1.0            \
        SETB    P1.1            \
        RET                     \




\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\
\ Rotina que prepara o valor do contador para o LCD
\
label   SUM
        PUSH    ACC             \
        MOV     $35 , # $00     \
        MOV     $34 , R3        \
        MOV     R5 , $34        \
        MOV     R0 , # $33      \
        MOV     A , R5          \
        MOV     B , # $04       \
        MUL     AB              \
        ADD     A , # $11       \
        MOV     R5 , A          \
BEGIN
        PUSH    ACC             \
        MOV     A , $35         \
        MOV     $35 , # $00     \
        RRC     A               \
        POP     ACC             \
        MOVC    A , @A+PC       \ le valores da tab.
                                \ de conversao
        ADDC    A , @R0         \ soma novo valor ao
        DA      A               \ ao valor antigo
        if c?                   \ passa a decimal
           MOV     $35 , # $01     \
        endif
        MOV     @R0 , A         \
        INC     R5              \
        MOV     A , R5          \
        DEC     R0              \
UNTIL   R0= # $2F
        POP     ACC             \
        RET                     \
\
        word   $8608            \ 2^23
        word   $0838            \
        word   $4304            \ 2^22
        word   $0419            \
        word   $7152            \ 2^21
        word   $0209            \
        word   $8576            \ 2^20
        word   $0104            \
        word   $4288            \ 2^19
        word   $0052            \
        word   $2144            \ 2^18
        word   $0026            \
        word   $1072            \ 2^17
        word   $0013            \
        word   $5536            \ 2^16
        word   $0006            \
        word   $2768            \ 2^15
        word   $0003            \
        word   $6384            \ 2^14
        word   $0001            \
        word   $8192            \ 2^13
        word   $0000            \
        word   $4096            \ 2^12
        word   $0000            \
        word   $2048            \ 2^11
        word   $0000            \
        word   $1024            \ 2^10
        word   $0000            \
        word   $0512            \ 2^09
        word   $0000            \
        word   $0256            \ 2^08
        word   $0000            \
        word   $0128            \ 2^07
        word   $0000            \
        word   $0064            \ 2^06
        word   $0000            \
        word   $0032            \ 2^05
        word   $0000            \
        word   $0016            \ 2^04
        word   $0000            \
        word   $0008            \ 2^03
        word   $0000            \
        word   $0004            \ 2^02
        word   $0000            \
        word   $0002            \ 2^01
        word   $0000            \
        word   $0001            \ 2^00
        word   $0000            \


\ ************************************************************
\
\ Rotina de visualizacao do estado das contagens
\

label   VISCONT
        MOV     $30 , # $00        \ carrega buffer
        MOV     $31 , # $00        \ onde sera guardado
        MOV     $32 , # $00        \ numero convertido
        MOV     $33 , # $00        \ dos tres bytes
\
        MOV     DPTR , # BECNT 1 -    \ coloca apontador
                                      \ no buffer da U.A.
                                      \ a ser visualizada
        MOV     R2 , # NBAC 1 +       \ numero de bytes a
                                      \ serem convertidos
        MOV     R3 , # 00             \ 'apontador' para
                                      \ o buffer de conv.


   BEGIN
           DEC     R2
   WHILE R2= # 0
           INC     DPTR                     \
           MOVX    A , @DPTR                \ carrega BAC
                IF  A= # 00                 \ se = 0 entao
                    MOV     A , R3          \ salta para o byte
                    ADD     A , # $08       \ seguinte
                    MOV     R3 , A          \
                 ELSE
                    MOV     R4 , # $08
                    BEGIN                    \ se <> 0 vai ver
                       RLC     A             \ quais os bits que
                       IF  c?                \ sao 1
                          ACALL   SUM        \
                       ENDIF
                       INC     R3
                       DEC     R4
                    UNTIL  R4= # 0
                ENDIF
   REPEAT


\
\ Depois da conversao e visualizado no LCD o valor
\ em decimal (8 digitos) dos tres bytes adquiridos
\

        MOV     A , # $0C8       \ coluna 7 linha 2
        ACALL   CMD             \
        MOV     R0 , # $30      \

BEGIN   MOV     A , @R0         \ escreve valor
        SWAP    A               \
        ANL     A , $0F         \
        ORL     A , # $30       \ convertido dos
        ACALL   CRT             \ tres bytes
        MOV     A , @R0         \
        ANL     A , # $0F       \
        ORL     A , # $30       \
        ACALL   CRT             \
        INC     R0              \
UNTIL   R0= # $34               \
        RET                     \




\ \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
\  inicio real do programa

        label  INICIO
\
\ Inicializacao do uP8031
\
        MOV     SP ,  # $50         \ inicializa STACK
        MOV     IE ,  # $82         \ inicializa IE
        MOV     IP ,  # $02         \ inicializa IP
        MOV     TMOD , # $05        \ inicializa TMOD
                                   \ T/C0 as Counter
        MOV     TH0 , # $00        \
        MOV     TL0 , # $00        \
        MOV     IT0 , # $10       \ activa Counter
                                   \ bit TR0=1
\
\ Inicializacao do LCD
\
        label INILCD

        MOV     A , # $38       \ function set
        ACALL   CMD             \
        MOV     A , # $0C       \ LCD on/off control
        ACALL   CMD             \
        MOV     A , # $06       \ entry mode set
        ACALL   CMD             \
        MOV     A , # $01       \ clear display
        ACALL   CMD             \
\
\ Cria visual no LCD da Unidade de Aquisicao
\
        MOV     A , # $80       \ linha 1 coluna 1
        ACALL   CMD             \
        MOV     A , # $00       \ "UR."
        ACALL   SAY             \
        MOV     A , # $86       \ linha 1 coluna 7
        ACALL   CMD             \
        MOV     A , # $20       \ "E:"
        ACALL   SAY             \
        MOV     A , # $C6       \ linha 2 coluna 7
        ACALL   CMD             \
        MOV     A , # $23       \ "C:"
        ACALL   SAY             \
        MOV     A , # $83       \ linha 1 coluna 6
        ACALL   CMD             \
        MOV     A , P1          \ le porta P1
        RR      A               \
        RR      A               \
        ANL     A , # $03       \
        MOV     R3 , A          \
        SWAP    A               \
        ANL     A , # $0F       \

        if     A= # $00                  \
                 MOV     A , # $20       \
                 ACALL   CRT             \
         else                            \
                 ORL     A , # $30       \
                 ACALL   CRT             \
        endif
        MOV     A , R3           \
        ANL     A , $0F          \
        ORL     A , # $30        \
        ACALL   CRT              \
\
\ Inicializa buffer que contera valores de contagem
\
        MOV     DPTR , # BECNT    \
        MOV     A , # 00          \
        MOV     $38 , A           \
        MOVX    @DPTR , A         \
        INC     DPTR              \
        MOV     A , # 00          \
        MOVX    @DPTR , A         \
        INC     DPTR              \
        MOV     A , # 00          \
        MOVX    @DPTR , A         \
\
\ Carrega o buffer que contem a informacao sobre o
\ estado dos contadores de uma unidade de aquisicao
\ e que sera convertido para um valor de 8 digitos
\
BEGIN
        MOV     A , # $88       \ linha 1 coluna 9
        ACALL   CMD             \
        MOV     A , P1          \ le porta P1
        SWAP    A               \
        ORL     A , # $F0       \

        IF A= # $F7                          \ compara com 0111
              MOV     A , # $04              \ "off"
              ACALL   SAY                    \
        ELSE
              IF  A= # $FB                   \ compara com 1011
                  MOV     A , # $0B          \ "avaria"
                  ACALL   SAY                \
              ELSE
                  IF A= # $FD                \ compara com 1101
                     MOV     A , # $12       \ "manut."
                     ACALL   SAY             \
                  ELSE
                     IF A= $FE
                       MOV     A , # $19     \ "on"
                       ACALL   SAY           \
                     ENDIF
                  ENDIF
              ENDIF
        ENDIF

        MOV     DPTR , # BECNT  \
        MOV     A , $38         \ byte mais alto a
        MOVX    @DPTR , A       \ ser convertido
        INC     DPTR            \
        MOV     A , TH0         \ byte do meio a
        MOVX    @DPTR , A       \ ser convertido
        INC     DPTR            \
        MOV     A , TL0         \ byte mais baixo a
        MOVX    @DPTR , A       \ ser convertido
        ACALL   VISCONT         \
AGAIN



\  ****************************************************************

    $af   constant IE.7

\
\ Rotina que processa a interrupcao gerada por
\ Overflow do contador T/C0
\

label   TIMER0
        CLR     IE.7            \ disable interrupts
        MOV     IT0 , # $10     \ apaga flag de Over
                                \ Flow do Counter 0
        INC     $38             \ incrementa byte 3
                                \ do Counter 0
        SETB    IE.7            \ enable interrupts
        RETI                    \
\

\ *******************************************************************
\   boot code
\
        ORG    $0000
\
        AJMP    INICIO          \
\
\ Interrupcao por TIMER0
\
        ORG    $000B
\
        LJMP    TIMER0          \


        CODE51;                \ end of code








